<html>
	<head>
		<meta charset="utf-8"/>
		<script src="wasm_exec.js"></script>
	</head>
	<body>
		<h1>WASM</h1>
        <h2>Experiments</h2>

		<script>

			// This is a polyfill for FireFox and Safari
			if (!WebAssembly.instantiateStreaming) { 
				WebAssembly.instantiateStreaming = async (resp, importObject) => {
					const source = await (await resp).arrayBuffer()
					return await WebAssembly.instantiate(source, importObject)
				}
			}

			// Promise to load the wasm file
			function loadWasm(path) {
				const go = new Go()

				return new Promise((resolve, reject) => {
					WebAssembly.instantiateStreaming(fetch(path), go.importObject)
					.then(result => {
						go.run(result.instance)
						resolve(result.instance)
					})
					.catch(error => {
						reject(error)
					})
				})
			}

			// Load the wasm file
			loadWasm("main.wasm").then(wasm => {
				console.log("main.wasm is loaded 👋")
				let data = HelloWorld()
				document.querySelector("h1").innerText = data.message
				document.querySelector("h2").innerText = data.author
			}).catch(error => {
				console.log("ouch", error)
			}) 


			
		</script>
	</body>
</html>
